#include <iostream>
#include <fstream>
#include <C:/Eigen/Eigen/Dense>
#include <iostream>
#include <math.h>
#include <vector>
#include <conio.h>

using namespace std;

const int L=1;      //     - 
int n=4;            //  

int main()
{
    float h=n/L;        //   
    float d=-h;        // ,     ,   
    int p=10;
    Eigen::MatrixXf K(n+1, n+1);    //   -
    Eigen::VectorXf f(n+1);         //   
    K(0,0)=1;       //  - 
    for (int i=1; i<n+1; ++i)       //  ,   
    {
        K(0,i)=0;
    }
    for (int i=1; i<n; ++i)         //   -
    {
        for (int j=0; j<n; ++j)
        {
            if (i==j)
            {
            K(i,j)=2*h;
            K(i,j-1)=d;
            K(i,j+1)=d;
            K(i+1,j)=d;
            }
            if (abs(i-j)>=2)
              K(i,j)=0;
        }
    }
    K(n,n)=h;

    for (int k=0; k<n; ++k)     //    
    {
        f(k)=0;
    }
    f(n)=p/(2*h);       //      
    cout << " Matrix K:\n" << K << endl;
    cout << "Vector f:\n" << f << endl;
    Eigen::VectorXf x = K.colPivHouseholderQr().solve(f);   //   
    cout << "Solution :\n" << x << endl;      //  
    return 0;
}

